>From 36d91bea7480db9c78e569513d404dad82e05474 Mon Sep 17 00:00:00 2001
From: Roiy Shpaner <roiy@cs.umanitoba.ca>
Date: Tue, 15 Apr 2014 18:53:07 -0500
Subject: [PATCH 05/10] MED Support - Interface and widgets

---
 modules/gui/qt4/Makefile.am                      |  24 +++
 modules/gui/qt4/actions_manager.cpp              |  35 ++++
 modules/gui/qt4/actions_manager.hpp              |  11 ++
 modules/gui/qt4/components/controller.cpp        | 163 +++++++++++++++-
 modules/gui/qt4/components/controller.hpp        |  40 +++-
 modules/gui/qt4/components/controller_widget.cpp |  38 ++++
 modules/gui/qt4/components/controller_widget.hpp |  27 +++
 modules/gui/qt4/components/interface_widgets.cpp | 230 +++++++++++++++++++++--
 modules/gui/qt4/components/interface_widgets.hpp |  25 ++-
 modules/gui/qt4/dialogs/toolbar.cpp              |  54 ++++++
 modules/gui/qt4/main_interface.cpp               |  18 +-
 modules/gui/qt4/main_interface.hpp               |   1 +
 modules/gui/qt4/util/annotation_tooltip.cpp      | 168 +++++++++++++++++
 modules/gui/qt4/util/annotation_tooltip.hpp      |  58 ++++++
 14 files changed, 865 insertions(+), 27 deletions(-)
 create mode 100644 modules/gui/qt4/util/annotation_tooltip.cpp
 create mode 100644 modules/gui/qt4/util/annotation_tooltip.hpp

diff --git a/modules/gui/qt4/Makefile.am b/modules/gui/qt4/Makefile.am
index 50594aa..d5630c5 100644
--- a/modules/gui/qt4/Makefile.am
+++ b/modules/gui/qt4/Makefile.am
@@ -43,8 +43,10 @@ libqt4_plugin_la_SOURCES = \
 	managers/addons_manager.cpp managers/addons_manager.hpp \
 	recents.cpp recents.hpp \
 	adapters/seekpoints.cpp adapters/seekpoints.hpp \
+	adapters/seeksegments.cpp adapters/seeksegments.hpp \
 	adapters/chromaprint.cpp adapters/chromaprint.hpp \
 	adapters/variables.cpp adapters/variables.hpp \
+	dialogs/annotations.cpp dialogs/annotations.hpp \
 	dialogs/playlist.cpp dialogs/playlist.hpp \
 	dialogs/bookmarks.cpp dialogs/bookmarks.hpp \
 	dialogs/preferences.cpp dialogs/preferences.hpp \
@@ -68,6 +70,13 @@ libqt4_plugin_la_SOURCES = \
 	dialogs/podcast_configuration.cpp dialogs/podcast_configuration.hpp \
 	dialogs/extensions.cpp dialogs/extensions.hpp \
 	dialogs/fingerprintdialog.cpp dialogs/fingerprintdialog.hpp \
+	dialogs/delete_event.cpp dialogs/delete_event.hpp \
+	dialogs/edit_event.cpp dialogs/edit_event.hpp \
+	dialogs/event_properties.cpp dialogs/event_properties.hpp \
+	dialogs/events_layers.cpp dialogs/events_layers.hpp \
+	dialogs/new_layer.cpp dialogs/new_layer.hpp \
+	dialogs/save_med.cpp dialogs/save_med.hpp \
+	components/annotations_widget.cpp components/annotations_widget.hpp \
 	components/extended_panels.cpp components/extended_panels.hpp \
 	components/info_panels.cpp components/info_panels.hpp \
 	components/info_widgets.cpp components/info_widgets.hpp \
@@ -79,6 +88,8 @@ libqt4_plugin_la_SOURCES = \
 	components/interface_widgets.cpp components/interface_widgets.hpp \
 	components/controller.cpp components/controller.hpp \
 	components/controller_widget.cpp components/controller_widget.hpp \
+	components/create_event.cpp components/create_event.hpp \
+	components/events_layers_widget.cpp components/events_layers_widget.hpp \
 	components/epg/EPGChannels.cpp components/epg/EPGChannels.hpp \
 	components/epg/EPGItem.cpp components/epg/EPGItem.hpp \
 	components/epg/EPGRuler.cpp components/epg/EPGRuler.hpp \
@@ -104,6 +115,7 @@ libqt4_plugin_la_SOURCES = \
 	util/animators.cpp util/animators.hpp \
 	util/input_slider.cpp util/input_slider.hpp \
 	util/timetooltip.cpp util/timetooltip.hpp \
+	util/annotation_tooltip.cpp util/annotation_tooltip.hpp \
 	util/customwidgets.cpp util/customwidgets.hpp \
 	util/searchlineedit.cpp util/searchlineedit.hpp \
 	util/registry.cpp util/registry.hpp \
@@ -145,8 +157,10 @@ nodist_libqt4_plugin_la_SOURCES = \
 	managers/addons_manager.moc.cpp \
 	recents.moc.cpp \
 	adapters/seekpoints.moc.cpp \
+	adapters/seeksegments.moc.cpp \
 	adapters/chromaprint.moc.cpp \
 	adapters/variables.moc.cpp \
+	dialogs/annotations.moc.cpp \
 	dialogs/playlist.moc.cpp \
 	dialogs/bookmarks.moc.cpp \
 	dialogs/mediainfo.moc.cpp \
@@ -170,6 +184,13 @@ nodist_libqt4_plugin_la_SOURCES = \
 	dialogs/extensions.moc.cpp \
 	dialogs/fingerprintdialog.moc.cpp \
 	dialogs/ml_configuration.moc.cpp \
+	dialogs/delete_event.moc.cpp \
+	dialogs/edit_event.moc.cpp \
+	dialogs/event_properties.moc.cpp \
+	dialogs/events_layers.moc.cpp \
+	dialogs/new_layer.moc.cpp \
+	dialogs/save_med.moc.cpp \
+	components/annotations_widget.moc.cpp \
 	components/extended_panels.moc.cpp \
 	components/info_panels.moc.cpp \
 	components/info_widgets.moc.cpp \
@@ -180,6 +201,8 @@ nodist_libqt4_plugin_la_SOURCES = \
 	components/interface_widgets.moc.cpp \
 	components/controller.moc.cpp \
 	components/controller_widget.moc.cpp \
+	components/create_event.moc.cpp \
+	components/events_layers_widget.moc.cpp \
 	components/epg/EPGChannels.moc.cpp \
 	components/epg/EPGRuler.moc.cpp \
 	components/epg/EPGView.moc.cpp \
@@ -196,6 +219,7 @@ nodist_libqt4_plugin_la_SOURCES = \
 	util/animators.moc.cpp \
 	util/input_slider.moc.cpp \
 	util/timetooltip.moc.cpp \
+	util/annotation_tooltip.moc.cpp \
 	util/customwidgets.moc.cpp \
 	util/searchlineedit.moc.cpp \
 	util/qmenuview.moc.cpp \
diff --git a/modules/gui/qt4/actions_manager.cpp b/modules/gui/qt4/actions_manager.cpp
index d5595fd..01680c4 100644
--- a/modules/gui/qt4/actions_manager.cpp
+++ b/modules/gui/qt4/actions_manager.cpp
@@ -85,6 +85,15 @@ void ActionsManager::doAction( int id_action )
         case SKIP_FW_ACTION:
             skipForward();
             break;
+        case PREV_SEGMENT_ACTION:
+            prevSegment();
+            break;
+        case NEXT_SEGMENT_ACTION:
+            nextSegment();
+            break;
+        case AUTO_JUMP_ACTION:
+            THEMIM->toggleAutoJump();
+            break;
         case QUIT_ACTION:
             THEDP->quit();  break;
         case RANDOM_ACTION:
@@ -97,6 +106,18 @@ void ActionsManager::doAction( int id_action )
             if( p_intf->p_sys->p_mi )
                 p_intf->p_sys->p_mi->getFullscreenControllerWidget()->toggleFullwidth();
             break;
+        case ANNOTATIONS_ACTION:
+            THEDP->annotationsDialog(); break;
+        case EVENT_LAYERS_ACTION:
+            THEDP->eventLayersDialog(); break;
+        case NEW_EVENT_ACTION:
+            THEDP->createEventDialog(); break;
+        case EDIT_EVENT_ACTION:
+            THEDP->editEventDialog(); break;
+        case DELETE_EVENT_ACTION:
+            THEDP->deleteEventDialog(); break;
+        case CHOOSE_SAVE_ACTION:
+            THEDP->saveMedDialog(); break;
         default:
             msg_Dbg( p_intf, "Action: %i", id_action );
             break;
@@ -205,3 +226,17 @@ void ActionsManager::skipBackward()
         THEMIM->getIM()->jumpBwd();
 }
 
+void ActionsManager::prevSegment()
+{
+    input_thread_t *p_input = THEMIM->getInput();
+    if( p_input )
+        THEMIM->getIM()->prevSegment();
+}
+
+void ActionsManager::nextSegment()
+{
+    input_thread_t *p_input = THEMIM->getInput();
+    if( p_input )
+        THEMIM->getIM()->nextSegment();
+}
+
diff --git a/modules/gui/qt4/actions_manager.hpp b/modules/gui/qt4/actions_manager.hpp
index a694579..ef1deed 100644
--- a/modules/gui/qt4/actions_manager.hpp
+++ b/modules/gui/qt4/actions_manager.hpp
@@ -56,6 +56,15 @@ typedef enum actionType_e
     LOOP_ACTION,
     INFO_ACTION,
     OPEN_SUB_ACTION,
+    ANNOTATIONS_ACTION,
+    EVENT_LAYERS_ACTION,
+    PREV_SEGMENT_ACTION,
+    NEXT_SEGMENT_ACTION,
+    AUTO_JUMP_ACTION,
+    NEW_EVENT_ACTION,
+    EDIT_EVENT_ACTION,
+    DELETE_EVENT_ACTION,
+    CHOOSE_SAVE_ACTION
 } actionType_e;
 
 class ActionsManager : public QObject
@@ -90,6 +99,8 @@ public slots:
     void record();
     void skipForward();
     void skipBackward();
+    void prevSegment();
+    void nextSegment();
 protected slots:
     void fullscreen();
     void snapshot();
diff --git a/modules/gui/qt4/components/controller.cpp b/modules/gui/qt4/components/controller.cpp
index d2ed608..fb0f248 100644
--- a/modules/gui/qt4/components/controller.cpp
+++ b/modules/gui/qt4/components/controller.cpp
@@ -43,6 +43,7 @@
 #include "util/customwidgets.hpp"                       /* qEventToKey */
 
 #include "adapters/seekpoints.hpp"
+#include "adapters/seeksegments.hpp"
 
 #include <QToolButton>
 #include <QHBoxLayout>
@@ -66,6 +67,7 @@ AbstractController::AbstractController( intf_thread_t * _p_i, QWidget *_parent )
 {
     p_intf = _p_i;
     advControls = NULL;
+    medControls = NULL;
     buttonGroupLayout = NULL;
 
     /* Main action provider */
@@ -312,8 +314,20 @@ QWidget *AbstractController::createWidget( buttonType_e button, int options )
         NORMAL_BUTTON( EXTENDED );
         }
         break;
-    case PLAYLIST_BUTTON:{
-        NORMAL_BUTTON( PLAYLIST );
+    case ANNOTATIONS_BUTTON:{
+        NORMAL_BUTTON( ANNOTATIONS );
+        }
+        break;
+    case EVENT_LAYERS_BUTTON:{
+        NORMAL_BUTTON( EVENT_LAYERS );
+        }
+        break;
+    case PREV_SEGMENT_BUTTON:{
+        NORMAL_BUTTON( PREV_SEGMENT );
+        }
+        break;
+    case NEXT_SEGMENT_BUTTON:{
+        NORMAL_BUTTON( NEXT_SEGMENT );
         }
         break;
     case SNAPSHOT_BUTTON:{
@@ -346,14 +360,23 @@ QWidget *AbstractController::createWidget( buttonType_e button, int options )
         }
         break;
     case INPUT_SLIDER: {
-        SeekSlider *slider = new SeekSlider( Qt::Horizontal, NULL, !b_shiny );
+        SeekSlider *slider = new SeekSlider( Qt::Horizontal, NULL, p_intf, !b_shiny );
         SeekPoints *chapters = new SeekPoints( this, p_intf );
         CONNECT( THEMIM->getIM(), chapterChanged( bool ), chapters, update() );
         slider->setChapters( chapters );
 
+        SeekSegments *events = new SeekSegments( this, p_intf );
+        slider->setEvents( events );
+        CONNECT( THEMIM->getIM(), eventsChanged( bool ), events, updateMain() );
+        CONNECT( THEMIM->getIM(), layersChanged( ), events, updateMain() );
+        CONNECT( THEMIM->getIM(), layersChanged( ), slider, repaint() );
+        CONNECT( THEMIM->getIM(), setEditMode( EditState ), slider, setEditMode( EditState ) );
+        CONNECT( slider, switchEdit( bool ), THEMIM->getIM(), switchUiEditMode( bool ) );
+        CONNECT( THEMIM->getIM(), updateEventTimes( int64_t, int64_t ), slider, setEventTimes( int64_t, int64_t ) );
+
         /* Update the position when the IM has changed */
-        CONNECT( THEMIM->getIM(), positionUpdated( float, int64_t, int ),
-                slider, setPosition( float, int64_t, int ) );
+        CONNECT( THEMIM->getIM(), positionUpdated( float, int64_t, int64_t ),
+                slider, setPosition( float, int64_t, int64_t ) );
         /* And update the IM, when the position has changed */
         CONNECT( slider, sliderDragged( float ),
                  THEMIM->getIM(), sliderUpdate( float ) );
@@ -385,6 +408,25 @@ QWidget *AbstractController::createWidget( buttonType_e button, int options )
         {
             TimeLabel *timeLabel = new TimeLabel( p_intf );
             widget = timeLabel;
+            CONNECT( THEMIM->getIM(), layersChanged( ), widget, clearCache() );
+            CONNECT( THEMIM->getIM(), eventsChanged( bool ), widget, clearCache() );
+        }
+        break;
+    case SEGMENTS_TIME_LABEL:
+        {
+            widget = new SegmentsTimeLabel( p_intf );
+            CONNECT( THEMIM->getIM(), layersChanged( ), widget, clearCache() );
+        }
+        break;
+    case SEGMENTS_TIME_LABEL_ELAPSED:
+        {
+            widget = new SegmentsTimeLabel( p_intf, TimeLabel::Elapsed );
+        }
+        break;
+    case SEGMENTS_TIME_LABEL_REMAINING:
+        {
+            widget = new SegmentsTimeLabel( p_intf, TimeLabel::Remaining );
+            CONNECT( THEMIM->getIM(), layersChanged( ), widget, clearCache() );
         }
         break;
     case SPLITTER:
@@ -403,6 +445,12 @@ QWidget *AbstractController::createWidget( buttonType_e button, int options )
             widget = advControls;
         }
         break;
+    case MED_CONTROLLER:
+        {
+            medControls = new MedControlsWidget( p_intf, this );
+            widget = medControls;
+        }
+        break;
     case REVERSE_BUTTON:{
         QToolButton *reverseButton = new QToolButton;
         setupButton( reverseButton );
@@ -426,6 +474,20 @@ QWidget *AbstractController::createWidget( buttonType_e button, int options )
         ENABLE_ON_INPUT( SKIP_FWButton );
         }
         break;
+    case AUTO_JUMP_BUTTON: {
+        AutoJumpButton *autoJumpButton = new AutoJumpButton;
+        setupButton( autoJumpButton );
+        BUTTON_SET_BAR( autoJumpButton );
+        CONNECT_MAP_SET( autoJumpButton, AUTO_JUMP_ACTION );
+
+        CONNECT( THEMIM, autoJumpChanged( bool ),
+                 autoJumpButton, updateButtonIcons( bool ) );
+        CONNECT( THEMIM, setAutoJumpBtn( bool ),
+                autoJumpButton, setEnabled( bool ) );
+
+        widget = autoJumpButton;
+        }
+        break;
     case QUIT_BUTTON: {
         NORMAL_BUTTON( QUIT );
         }
@@ -480,6 +542,11 @@ QWidget *AbstractController::createWidget( buttonType_e button, int options )
         break;
     case TIME_LABEL_REMAINING:
         widget = new TimeLabel( p_intf, TimeLabel::Remaining );
+        CONNECT( THEMIM->getIM(), layersChanged( ), widget, clearCache() );
+        CONNECT( THEMIM->getIM(), eventsChanged( bool ), widget, clearCache() );
+        break;
+    case EVENTS_EDITOR:
+        widget = eventsFrame();
         break;
     default:
         msg_Warn( p_intf, "This should not happen %i", button );
@@ -563,6 +630,41 @@ QFrame *AbstractController::discFrame()
     return discFrame;
 }
 
+QFrame *AbstractController::eventsFrame()
+{
+    /** Events and annotations handling */
+    QFrame *eventsFrame = new QFrame( this );
+
+    QHBoxLayout *eventsLayout = new QHBoxLayout( eventsFrame );
+    eventsLayout->setSpacing( 0 ); eventsLayout->setMargin( 0 );
+
+    QToolButton *newEventButton = new QToolButton( eventsFrame );
+    setupButton( newEventButton );
+    BUTTON_SET_BAR2( newEventButton, util/create_event, qtr("Create new event") );
+    CONNECT_MAP_SET( newEventButton, NEW_EVENT_ACTION );
+    eventsLayout->addWidget( newEventButton );
+
+    QToolButton *editEventButton = new QToolButton( eventsFrame );
+    setupButton( editEventButton );
+    BUTTON_SET_BAR2( editEventButton, util/edit_event, qtr("Edit existing event") );
+    CONNECT_MAP_SET( editEventButton, EDIT_EVENT_ACTION );
+    eventsLayout->addWidget( editEventButton );
+
+    QToolButton *deleteEventButton = new QToolButton( eventsFrame );
+    setupButton( deleteEventButton );
+    BUTTON_SET_BAR2( deleteEventButton, util/delete_event, qtr("Delete event") );
+    CONNECT_MAP_SET( deleteEventButton, DELETE_EVENT_ACTION );
+    eventsLayout->addWidget( deleteEventButton );
+
+    QToolButton *saveEventsData = new QToolButton( eventsFrame );
+    setupButton( saveEventsData );
+    BUTTON_SET_BAR2( saveEventsData, util/save_events, qtr("Save events data to file") );
+    CONNECT_MAP_SET( saveEventsData, CHOOSE_SAVE_ACTION );
+    eventsLayout->addWidget( saveEventsData );
+
+    return eventsFrame;
+}
+
 QFrame *AbstractController::telexFrame()
 {
     /**
@@ -674,13 +776,14 @@ QFrame *AbstractController::telexFrame()
  * DA Control Widget !
  *****************************/
 ControlsWidget::ControlsWidget( intf_thread_t *_p_i,
-                                bool b_advControls,
+                                bool b_advControls, QString str_MedControls,
                                 QWidget *_parent ) :
                                 AbstractController( _p_i, _parent )
 {
     RTL_UNAFFECTED_WIDGET
     /* advanced Controls handling */
     b_advancedVisible = b_advControls;
+    str_MedControlState = str_MedControls;
 #ifdef DEBUG_LAYOUT
     setStyleSheet( "background: red ");
 #endif
@@ -693,6 +796,9 @@ ControlsWidget::ControlsWidget( intf_thread_t *_p_i,
 
     QString line1 = getSettings()->value( "MainWindow/MainToolbar1", MAIN_TB1_DEFAULT )
                                         .toString();
+    QString medController = QString::number(MED_CONTROLLER);
+    if ( !line1.contains( medController ) )
+        line1 = medController + qtr(";") + line1;  /* MED controller is hidden unless needed or explicitly set */
     parseAndCreate( line1, controlLayout1 );
 
     QHBoxLayout *controlLayout2 = new QHBoxLayout;
@@ -706,6 +812,13 @@ ControlsWidget::ControlsWidget( intf_thread_t *_p_i,
 
     if( !b_advancedVisible && advControls ) advControls->hide();
 
+    if ( strcmp( qtu(str_MedControlState), "show" ) == 0 )
+    {
+        if( medControls ) medControls->show();
+    }
+    else
+        if( medControls ) medControls->hide();
+
     controlLayout->addLayout( controlLayout1 );
     controlLayout->addLayout( controlLayout2 );
 }
@@ -719,6 +832,26 @@ void ControlsWidget::toggleAdvanced()
     emit advancedControlsToggled( b_advancedVisible );
 }
 
+void ControlsWidget::setMedControls( bool bShow )
+{
+    if( !medControls ) return;
+
+    char* psz_med = var_GetString( p_intf, "med-view" );
+
+    if ( strcmp( psz_med, "showIfDetected" ) == 0 )
+    {
+        medControls->setVisible( bShow );
+    }
+    else if ( strcmp( psz_med, "show" ) == 0 )
+    {
+        medControls->setVisible( true );
+    }
+    else if ( strcmp( psz_med, "hide" ) == 0 )
+    {
+        medControls->setVisible( false );
+    }
+}
+
 AdvControlsWidget::AdvControlsWidget( intf_thread_t *_p_i, QWidget *_parent ) :
                                      AbstractController( _p_i, _parent )
 {
@@ -736,6 +869,23 @@ AdvControlsWidget::AdvControlsWidget( intf_thread_t *_p_i, QWidget *_parent ) :
     parseAndCreate( line, controlLayout );
 }
 
+MedControlsWidget::MedControlsWidget( intf_thread_t *_p_i, QWidget *_parent ) :
+                                     AbstractController( _p_i, _parent )
+{
+    RTL_UNAFFECTED_WIDGET
+    controlLayout = new QHBoxLayout( this );
+    controlLayout->setMargin( 0 );
+    controlLayout->setSpacing( 0 );
+#ifdef DEBUG_LAYOUT
+    setStyleSheet( "background: orange ");
+#endif
+
+
+    QString line = getSettings()->value( "MainWindow/MedToolbar", MED_TB_DEFAULT )
+        .toString();
+    parseAndCreate( line, controlLayout );
+}
+
 InputControlsWidget::InputControlsWidget( intf_thread_t *_p_i, QWidget *_parent ) :
                                      AbstractController( _p_i, _parent )
 {
@@ -750,6 +900,7 @@ InputControlsWidget::InputControlsWidget( intf_thread_t *_p_i, QWidget *_parent
     QString line = getSettings()->value( "MainWindow/InputToolbar", INPT_TB_DEFAULT ).toString();
     parseAndCreate( line, controlLayout );
 }
+
 /**********************************************************************
  * Fullscrenn control widget
  **********************************************************************/
diff --git a/modules/gui/qt4/components/controller.hpp b/modules/gui/qt4/components/controller.hpp
index b22e430..727fa42 100644
--- a/modules/gui/qt4/components/controller.hpp
+++ b/modules/gui/qt4/components/controller.hpp
@@ -34,9 +34,10 @@
 #include <QString>
 #include <QSizeGrip>
 
-#define MAIN_TB1_DEFAULT "64;39;64;38;65"
+#define MAIN_TB1_DEFAULT "49;64;39;64;38;65"
 #define MAIN_TB2_DEFAULT "0-2;64;3;1;4;64;7;9;64;10;20;19;64-4;37;65;35-4"
 #define ADV_TB_DEFAULT "12;11;13;14"
+#define MED_TB_DEFAULT "29;26;30;64;27;28;64;48"
 #define INPT_TB_DEFAULT "43;33-4;44"
 #define FSC_TB_DEFAULT "0-2;64;3;1;4;64;37;64;38;64;8;65;25;35-4;34"
 
@@ -89,7 +90,13 @@ typedef enum buttonType_e
     NEXT_BUTTON,
     OPEN_SUB_BUTTON,
     FULLWIDTH_BUTTON,
+    ANNOTATIONS_BUTTON,   
+    PREV_SEGMENT_BUTTON,
+    NEXT_SEGMENT_BUTTON,
+    EVENT_LAYERS_BUTTON,
+    AUTO_JUMP_BUTTON,
     BUTTON_MAX,
+    
 
     SPLITTER = 0x20,
     INPUT_SLIDER,
@@ -104,6 +111,11 @@ typedef enum buttonType_e
     SPEED_LABEL,
     TIME_LABEL_ELAPSED,
     TIME_LABEL_REMAINING,
+    SEGMENTS_TIME_LABEL,
+    SEGMENTS_TIME_LABEL_ELAPSED,
+    SEGMENTS_TIME_LABEL_REMAINING,
+    EVENTS_EDITOR,
+    MED_CONTROLLER,
     SPECIAL_MAX,
 
     WIDGET_SPACER = 0x40,
@@ -118,7 +130,8 @@ static const char* const nameL[BUTTON_MAX] = { N_("Play"), N_("Stop"), N_("Open"
     N_("Record"), N_("A->B Loop"), N_("Frame By Frame"), N_("Trickplay Reverse"),
     N_("Step backward" ), N_("Step forward"), N_("Quit"), N_("Random"),
     N_("Loop / Repeat"), N_("Information"), N_("Previous"), N_("Next"),
-    N_("Open subtitles"), N_("Dock fullscreen controller")
+    N_("Open subtitles"), N_("Dock fullscreen controller"), N_("Annotations"),
+    N_("Previous Event"), N_("Next Event"), N_("Events Layers"), N_("Events Auto Jump")
 };
 static const char* const tooltipL[BUTTON_MAX] = { I_PLAY_TOOLTIP,
     N_("Stop playback"), N_("Open a medium"),
@@ -132,7 +145,9 @@ static const char* const tooltipL[BUTTON_MAX] = { I_PLAY_TOOLTIP,
     N_("Random"), N_("Change the loop and repeat modes"), N_("Information"),
     N_("Previous media in the playlist"), N_("Next media in the playlist"),
     N_("Open subtitle file"),
-    N_("Dock/undock fullscreen controller to/from bottom of screen")
+    N_("Dock/undock fullscreen controller to/from bottom of screen"),
+    N_("Open media annotations"), N_("Jump to previous event"), N_("Jump to next event"), N_("Open events layers control"),
+    N_("Enable/Disable Auto jump to events")
 };
 static const QString iconL[BUTTON_MAX] ={ ":/toolbar/play_b", ":/toolbar/stop_b",
     ":/toolbar/eject", ":/toolbar/previous_b", ":/toolbar/next_b",
@@ -142,7 +157,8 @@ static const QString iconL[BUTTON_MAX] ={ ":/toolbar/play_b", ":/toolbar/stop_b"
     ":/toolbar/frame", ":/toolbar/reverse", ":/toolbar/skip_back",
     ":/toolbar/skip_fw", ":/toolbar/clear", ":/buttons/playlist/shuffle_on",
     ":/buttons/playlist/repeat_all", ":/menu/info",
-    ":/toolbar/previous_b", ":/toolbar/next_b", ":/toolbar/eject", ":/toolbar/space"
+    ":/toolbar/previous_b", ":/toolbar/next_b", ":/toolbar/eject", ":/toolbar/space",
+    ":/toolbar/annotations", ":/toolbar/dvd_prev", ":/toolbar/dvd_next", ":/prefsmenu/advanced/intf", ":/toolbar/skip_fw"
 };
 
 enum
@@ -154,6 +170,7 @@ enum
 };
 
 class AdvControlsWidget;
+class MedControlsWidget;
 class AbstractController : public QFrame
 {
     friend class WidgetListing; /* For ToolBar Edition HACKS */
@@ -171,6 +188,8 @@ protected:
 
     AdvControlsWidget   *advControls;
 
+    MedControlsWidget   *medControls;
+
     void parseAndCreate( const QString& config, QBoxLayout *controlLayout );
 
     virtual void createAndAddWidget( QBoxLayout *controlLayout, int i_index,
@@ -180,6 +199,7 @@ protected:
 private:
     static void setupButton( QAbstractButton * );
     QFrame *discFrame();
+    QFrame *eventsFrame();
     QFrame *telexFrame();
     void applyAttributes( QToolButton *, bool b_flat, bool b_big );
 
@@ -202,6 +222,14 @@ public:
     AdvControlsWidget( intf_thread_t *, QWidget *_parent = 0 );
 };
 
+/* MED control Bar */
+class MedControlsWidget : public AbstractController
+{
+    Q_OBJECT
+public:
+    MedControlsWidget( intf_thread_t *, QWidget *_parent = 0 );
+};
+
 /* Slider Bar */
 class InputControlsWidget : public AbstractController
 {
@@ -216,7 +244,7 @@ class ControlsWidget : public AbstractController
     Q_OBJECT
 public:
     /* p_intf, advanced control visible or not, blingbling or not */
-    ControlsWidget( intf_thread_t *_p_i, bool b_advControls,
+    ControlsWidget( intf_thread_t *_p_i, bool b_advControls, QString str_MedControls,
                     QWidget *_parent = 0 );
 
     void setGripVisible( bool b_visible )
@@ -226,12 +254,14 @@ protected:
     friend class MainInterface;
 
     bool b_advancedVisible;
+    QString str_MedControlState;   //MED control setting - show when detected / always show/hide
 
 private:
     QSizeGrip *grip;
 
 protected slots:
     void toggleAdvanced();
+    void setMedControls( bool );
 
 signals:
     void advancedControlsToggled( bool );
diff --git a/modules/gui/qt4/components/controller_widget.cpp b/modules/gui/qt4/components/controller_widget.cpp
index db27f3b..6643209 100644
--- a/modules/gui/qt4/components/controller_widget.cpp
+++ b/modules/gui/qt4/components/controller_widget.cpp
@@ -30,6 +30,7 @@
 
 #include "input_manager.hpp"         /* Get notification of Volume Change */
 #include "util/input_slider.hpp"     /* SoundSlider */
+#include "components/events_layers_widget.hpp"
 
 #include <math.h>
 
@@ -248,6 +249,11 @@ void AtoB_Button::updateButtonIcons( bool timeA, bool timeB )
     }
 }
 
+void AutoJumpButton::updateButtonIcons( bool b_jump )
+{
+    setIcon( b_jump ? QIcon( ":/toolbar/skip_fw" ) : QIcon( ":/toolbar/no_auto_jump" ) );
+}
+
 void LoopButton::updateButtonIcons( int value )
 {
     setChecked( value != NORMAL );
@@ -255,6 +261,38 @@ void LoopButton::updateButtonIcons( int value )
                                      : QIcon( ":/buttons/playlist/repeat_all" ) );
 }
 
+void AddRemLayerButton::toggleAddRemoveLayer()
+{
+    input_thread_t *p_input = playlist_CurrentInput( THEPL );
+    if ( !p_input )
+        return;
+
+    bAdded = !bAdded;
+    if ( bAdded )
+    {
+        input_Control( p_input, INPUT_SELECT_LAYER , iLayerId);
+
+        EventsLayersWidget *widget = (EventsLayersWidget*)parent();
+        widget->addLayerStyle( iLayerId );
+    }
+    else
+    {
+        input_Control( p_input, INPUT_DESELECT_LAYER , iLayerId);
+
+        EventsLayersWidget *widget = (EventsLayersWidget*)parent();
+        widget->removeLayerStyle( iLayerId );
+    }
+
+    THEMIM->getIM()->updateMedState();
+    vlc_object_release( p_input );
+}
+
+void AddRemLayerButton::extAddRemoveLayer( bool bAddCmd )
+{
+    if ( bAddCmd != bAdded )
+        toggleAddRemoveLayer();
+}
+
 void AspectRatioComboBox::updateRatios()
 {
     /* Clear the list before updating */
diff --git a/modules/gui/qt4/components/controller_widget.hpp b/modules/gui/qt4/components/controller_widget.hpp
index 3633eaa..c2fef27 100644
--- a/modules/gui/qt4/components/controller_widget.hpp
+++ b/modules/gui/qt4/components/controller_widget.hpp
@@ -34,6 +34,7 @@
 
 #include <QWidget>
 #include <QToolButton>
+#include <QPushButton>
 #include <QComboBox>
 
 class QLabel;
@@ -70,6 +71,32 @@ private slots:
     void updateButtonIcons( bool, bool );
 };
 
+class AutoJumpButton : public QToolButton
+{
+    Q_OBJECT
+private slots:
+    void updateButtonIcons( bool );
+};
+
+class AddRemLayerButton : public QPushButton
+{
+    Q_OBJECT
+public:
+    AddRemLayerButton( QWidget *_parent, intf_thread_t * _p_intf ): QPushButton( _parent ), p_intf ( _p_intf )
+    {
+        CONNECT( this, clicked( ),
+                 this, toggleAddRemoveLayer( ) );
+    }
+    int iLayerId;
+    bool bAdded;
+    void extAddRemoveLayer( bool bAddCmd );
+private slots:
+    void toggleAddRemoveLayer( );
+
+private:
+    intf_thread_t* p_intf;
+};
+
 class AspectRatioComboBox : public QComboBox
 {
     Q_OBJECT
diff --git a/modules/gui/qt4/components/interface_widgets.cpp b/modules/gui/qt4/components/interface_widgets.cpp
index af27f44..164bbcf 100644
--- a/modules/gui/qt4/components/interface_widgets.cpp
+++ b/modules/gui/qt4/components/interface_widgets.cpp
@@ -733,6 +733,9 @@ TimeLabel::TimeLabel( intf_thread_t *_p_intf, TimeLabel::Display _displayType  )
     : ClickableQLabel(), p_intf( _p_intf ), displayType( _displayType )
 {
     b_remainingTime = false;
+    cachedSegLength = 0;
+    cachedLength = 0;
+
     if( _displayType != TimeLabel::Elapsed )
         b_remainingTime = getSettings()->value( "MainWindow/ShowRemainingTime", false ).toBool();
     switch( _displayType ) {
@@ -757,14 +760,16 @@ TimeLabel::TimeLabel( intf_thread_t *_p_intf, TimeLabel::Display _displayType  )
     }
     setAlignment( Qt::AlignRight | Qt::AlignVCenter );
 
-    CONNECT( THEMIM->getIM(), positionUpdated( float, int64_t, int ),
-              this, setDisplayPosition( float, int64_t, int ) );
+    CONNECT( THEMIM->getIM(), positionUpdated( float, int64_t, int64_t ),
+              this, setDisplayPosition( float, int64_t, int64_t ) );
 
     setStyleSheet( "QLabel { padding-left: 4px; padding-right: 4px; }" );
 }
 
-void TimeLabel::setDisplayPosition( float pos, int64_t t, int length )
+void TimeLabel::setDisplayPosition( float pos, int64_t t, int64_t length )
 {
+    int lenSec = length / 1000000;
+
     if( pos == -1.f )
     {
         setMinimumSize( QSize( 0, 0 ) );
@@ -772,19 +777,68 @@ void TimeLabel::setDisplayPosition( float pos, int64_t t, int length )
             setText( "--:--/--:--" );
         else
             setText( "--:--" );
+
+        cachedSegLength = 0;
+        cachedLength = 0;
         return;
     }
+    
+    bool bMedExists, bMedActive, bAutoJump;
+    input_thread_t *p_input = playlist_CurrentInput( THEPL );
+
+    input_Control( p_input, INPUT_GET_MED_STATE, &bMedExists, &bMedActive );
+    input_Control( p_input, INPUT_GET_AUTO_JUMP, &bAutoJump );
+
+    if ( bMedExists && bAutoJump && bMedActive )   /* MED jump mode, calculate remaining segments time left  */
+    {
+        int64_t totalTime = -1;
+        int64_t totalSeg = -1;
+
+        if ( ( displayType == TimeLabel::Elapsed ) || ( displayType == TimeLabel::Both ) || ( b_remainingTime ) )
+            if ( input_Control( p_input, INPUT_GET_ANNOTATIONS_TIME, NULL, t, &totalTime )  /* get time elapsed for segments only */
+                != VLC_SUCCESS )
+            {
+                vlc_object_release( p_input );
+                return;
+            }
+
+        if ( ( displayType == TimeLabel::Remaining ) || ( displayType == TimeLabel::Both ) )
+        {
+            if ( cachedSegLength == 0 )    //Need to get total segments length
+            {
+                if ( input_Control( p_input, INPUT_GET_ANNOTATIONS_TIME, NULL, (int64_t)-1, &totalSeg )
+                    != VLC_SUCCESS )
+                {
+                    vlc_object_release( p_input );
+                    return;
+                }
+
+                cachedSegLength = totalSeg / 1000000;
+            }
+        }
+        
+        vlc_object_release( p_input );
 
-    int time = t / 1000000;
+        int time = totalTime / 1000000;
+
+        secstotimestr( psz_length, cachedSegLength );
+        secstotimestr( psz_time, ( b_remainingTime && cachedSegLength ) ? cachedSegLength - time
+                                                           : time );
+    }
+    else    /* Normal mode */
+    {
+        int time = t / 1000000;
 
-    secstotimestr( psz_length, length );
-    secstotimestr( psz_time, ( b_remainingTime && length ) ? length - time
+        secstotimestr( psz_length, lenSec );
+        secstotimestr( psz_time, ( b_remainingTime && lenSec ) ? lenSec - time
                                                            : time );
+    }
+    
 
     // compute the minimum size that will be required for the psz_length
     // and use it to enforce a minimal size to avoid "dancing" widgets
     QSize minsize( 0, 0 );
-    if ( length > 0 )
+    if ( lenSec > 0 )
     {
         QMargins margins = contentsMargins();
         minsize += QSize(
@@ -818,14 +872,14 @@ void TimeLabel::setDisplayPosition( float pos, int64_t t, int length )
         case TimeLabel::Both:
         default:
             QString timestr = QString( "%1%2/%3" )
-            .arg( QString( (b_remainingTime && length) ? "-" : "" ) )
+            .arg( QString( (b_remainingTime && lenSec) ? "-" : "" ) )
             .arg( QString( psz_time ) )
-            .arg( QString( ( !length && time ) ? "--:--" : psz_length ) );
+            .arg( QString( ( !lenSec && t ) ? "--:--" : psz_length ) );
 
             setText( timestr );
             break;
     }
-    cachedLength = length;
+    cachedLength = lenSec;
 }
 
 void TimeLabel::setDisplayPosition( float pos )
@@ -833,6 +887,7 @@ void TimeLabel::setDisplayPosition( float pos )
     if( pos == -1.f || cachedLength == 0 )
     {
         setText( " --:--/--:-- " );
+        cachedSegLength = 0;
         return;
     }
 
@@ -848,10 +903,163 @@ void TimeLabel::setDisplayPosition( float pos )
     setText( timestr );
 }
 
-
 void TimeLabel::toggleTimeDisplay()
 {
     b_remainingTime = !b_remainingTime;
     getSettings()->setValue( "MainWindow/ShowRemainingTime", b_remainingTime );
 }
 
+SegmentsTimeLabel::SegmentsTimeLabel( intf_thread_t *_p_intf, TimeLabel::Display _displayType )
+    : TimeLabel( _p_intf, _displayType  )
+{
+    switch( _displayType ) 
+    {
+        case TimeLabel::Elapsed:
+            setText( " --:-- " );
+            setToolTip( qtr("Elapsed segments time") );
+            break;
+        case TimeLabel::Remaining:
+            setText( " --:-- " );
+            setToolTip( qtr("Total/Remaining segments time")
+                        + QString("\n-")
+                        + qtr("Click to toggle between total and remaining time")
+                      );
+            break;
+        case TimeLabel::Both:
+            setText( " --:--/--:-- " );
+            setToolTip( QString( "- " )
+                + qtr( "Click to toggle between elapsed and remaining segments time" )
+                + QString( "\n- " )
+                + qtr( "Double click to jump to a chosen time position" ) );
+            break;
+    }
+    setAlignment( Qt::AlignRight | Qt::AlignVCenter );
+
+    cachedSegLength = 0;
+    psz_layerName = NULL;
+}
+
+void SegmentsTimeLabel::setDisplayPosition( float pos, int64_t t, int64_t length )
+{
+    VLC_UNUSED( length );
+
+    input_thread_t *p_input = playlist_CurrentInput( THEPL );
+
+    if( ( pos == -1.f ) || ( !p_input ) )
+    {
+        setMinimumSize( QSize( 0, 0 ) );
+        if( displayType == TimeLabel::Both )
+            setText( "--:--/--:--" );
+        else
+            setText( "--:--" );
+
+        cachedSegLength = 0;
+        return;
+    }
+
+    int64_t totalTime = -1;
+    int64_t totalSeg = -1;
+
+    if ( ( displayType == TimeLabel::Elapsed ) || ( displayType == TimeLabel::Both ) || ( b_remainingTime ) )
+        if ( input_Control( p_input, INPUT_GET_ANNOTATIONS_TIME, psz_layerName, t, &totalTime )
+            != VLC_SUCCESS )
+        {
+            vlc_object_release( p_input );
+            return;
+        }
+
+    if ( ( displayType == TimeLabel::Remaining ) || ( displayType == TimeLabel::Both ) )
+        if ( cachedSegLength == 0 )    //Need to get total segments length
+        {
+            if ( input_Control( p_input, INPUT_GET_ANNOTATIONS_TIME, psz_layerName, (int64_t)-1, &totalSeg )
+                != VLC_SUCCESS )
+            {
+                vlc_object_release( p_input );
+                return;
+            }
+
+            cachedSegLength = totalSeg / 1000000;
+        }
+    
+    vlc_object_release( p_input ); 
+
+    int time = totalTime / 1000000;
+
+    secstotimestr( psz_length, cachedSegLength );
+    secstotimestr( psz_time, ( b_remainingTime && cachedSegLength ) ? cachedSegLength - time
+                                                           : time );
+
+    // compute the minimum size that will be required for the psz_length
+    // and use it to enforce a minimal size to avoid "dancing" widgets
+    QSize minsize( 0, 0 );
+    if ( cachedSegLength > 0 )
+    {
+        QMargins margins = contentsMargins();
+        minsize += QSize(
+                  fontMetrics().size( 0, QString( psz_length ), 0, 0 ).width(),
+                  sizeHint().height()
+                );
+        minsize += QSize( margins.left() + margins.right() + 8, 0 ); /* +padding */
+
+        if ( b_remainingTime )
+            minsize += QSize( fontMetrics().size( 0, "-", 0, 0 ).width(), 0 );
+    }
+
+    switch( displayType )
+    {
+        case TimeLabel::Elapsed:
+            setMinimumSize( minsize );
+            setText( QString( psz_time ) );
+            break;
+        case TimeLabel::Remaining:
+            if( b_remainingTime )
+            {
+                setMinimumSize( minsize );
+                setText( QString("-") + QString( psz_time ) );
+            }
+            else
+            {
+                setMinimumSize( QSize( 0, 0 ) );
+                setText( QString( psz_length ) );
+            }
+            break;
+        case TimeLabel::Both:
+        default:
+            QString timestr = QString( "%1%2/%3" )
+            .arg( QString( (b_remainingTime && cachedSegLength) ? "-" : "" ) )
+            .arg( QString( psz_time ) )
+            .arg( QString( ( !cachedSegLength && time ) ? "--:--" : psz_length ) );
+
+            setText( timestr );
+            break;
+    }
+}
+
+void SegmentsTimeLabel::setDisplayPosition( float pos )
+{
+    if( pos == -1.f || cachedSegLength == 0)
+    {
+        setText( " --:--/--:-- " );
+        cachedSegLength = 0;
+        return;
+    }
+
+    int64_t time = pos * cachedSegLength * 1000000;
+
+    setDisplayPosition( pos, time, cachedSegLength * 1000000);
+}
+
+void SegmentsTimeLabel::clearCache( )
+{
+    cachedSegLength = 0;
+}
+
+void TimeLabel::clearCache( )
+{
+    cachedSegLength = 0;
+}
+
+SegmentsTimeLabel::~SegmentsTimeLabel()
+{
+    free ( psz_layerName );
+}
diff --git a/modules/gui/qt4/components/interface_widgets.hpp b/modules/gui/qt4/components/interface_widgets.hpp
index 520039f..9dc0e69 100644
--- a/modules/gui/qt4/components/interface_widgets.hpp
+++ b/modules/gui/qt4/components/interface_widgets.hpp
@@ -196,18 +196,37 @@ protected:
         toggleTimeDisplay();
         ClickableQLabel::mouseDoubleClickEvent( event );
     }
-private:
+protected:
     intf_thread_t *p_intf;
     bool b_remainingTime;
     int cachedLength;
+    int cachedSegLength;
     TimeLabel::Display displayType;
 
     char psz_length[MSTRTIME_MAX_SIZE];
     char psz_time[MSTRTIME_MAX_SIZE];
     void toggleTimeDisplay();
-private slots:
-    void setDisplayPosition( float pos, int64_t time, int length );
+protected slots:
+    virtual void setDisplayPosition( float pos, int64_t time, int64_t length );
+    virtual void setDisplayPosition( float pos );
+    void clearCache();
+};
+
+class SegmentsTimeLabel : public TimeLabel
+{
+    Q_OBJECT
+public:
+    SegmentsTimeLabel( intf_thread_t *_p_intf, TimeLabel::Display _displayType = TimeLabel::Both );
+    ~SegmentsTimeLabel();
+    char* psz_layerName;
+
+protected:
+    int cachedSegLength;
+
+protected slots:
+    void setDisplayPosition( float pos, int64_t time, int64_t length );
     void setDisplayPosition( float pos );
+    void clearCache();
 };
 
 class SpeedLabel : public QLabel
diff --git a/modules/gui/qt4/dialogs/toolbar.cpp b/modules/gui/qt4/dialogs/toolbar.cpp
index 1419704..10e3e8c 100644
--- a/modules/gui/qt4/dialogs/toolbar.cpp
+++ b/modules/gui/qt4/dialogs/toolbar.cpp
@@ -380,6 +380,21 @@ WidgetListing::WidgetListing( intf_thread_t *p_intf, QWidget *_parent )
             }
             widgetItem->setText( qtr("Time") );
             break;
+        case SEGMENTS_TIME_LABEL:
+            {
+                QLabel *segmentsTimeLabel = new QLabel( "12:42/2:12:42", this );
+                widget = segmentsTimeLabel;
+            }
+            widgetItem->setText( qtr("Segments Time") );
+            break;
+        case SEGMENTS_TIME_LABEL_ELAPSED:
+            widget = new QLabel( "2:42", this );
+            widgetItem->setText( qtr("Elapsed Segments Time") );
+            break;
+        case SEGMENTS_TIME_LABEL_REMAINING:
+            widget = new QLabel( "-2:42", this );
+            widgetItem->setText( qtr("Total/Remaining Segments time") );
+            break;
         case MENU_BUTTONS:
             {
                 QWidget *discFrame = new QWidget( this );
@@ -435,6 +450,13 @@ WidgetListing::WidgetListing( intf_thread_t *p_intf, QWidget *_parent )
             }
             widgetItem->setText( qtr("Advanced Buttons") );
             break;
+        case MED_CONTROLLER:
+            {
+                MedControlsWidget *medControls = new MedControlsWidget( p_intf, this );
+                widget = medControls;
+            }
+            widgetItem->setText( qtr("MED control Buttons") );
+            break;
         case PLAYBACK_BUTTONS:
             {
                 widget = new QWidget;
@@ -464,6 +486,38 @@ WidgetListing::WidgetListing( intf_thread_t *p_intf, QWidget *_parent )
             widget = new QLabel( "-2:42", this );
             widgetItem->setText( qtr("Total/Remaining time") );
             break;
+        case EVENTS_EDITOR:
+            {
+                //
+                QWidget *eventsFrame = new QWidget( this );
+                //discFrame->setLineWidth( 1 );
+                QHBoxLayout *eventsLayout = new QHBoxLayout( eventsFrame );
+                eventsLayout->setSpacing( 0 ); eventsLayout->setMargin( 0 );
+
+                QToolButton *newEventButton = new QToolButton( eventsFrame );
+                newEventButton->setIcon( QIcon( ":/util/create_event" ) );
+                newEventButton->setToolTip( qtr("Create new event") );
+                eventsLayout->addWidget( newEventButton );
+
+                QToolButton *editEventButton = new QToolButton( eventsFrame );
+                editEventButton->setIcon( QIcon( ":/util/edit_event" ) );
+                editEventButton->setToolTip( qtr("Edit existing event") );
+                eventsLayout->addWidget( editEventButton );
+
+                QToolButton *deleteEventButton = new QToolButton( eventsFrame );
+                deleteEventButton->setIcon( QIcon( ":/util/delete_event" ) );
+                deleteEventButton->setToolTip( qtr("Delete event") );
+                eventsLayout->addWidget( deleteEventButton );
+
+                QToolButton *saveEventsData = new QToolButton( eventsFrame );
+                saveEventsData->setIcon( QIcon( ":/util/save_events" ) );
+                saveEventsData->setToolTip( qtr("Save events data to file") );
+                eventsLayout->addWidget( saveEventsData );
+
+                widget = eventsFrame;
+            }
+            widgetItem->setText( qtr("Events Editor") );
+            break;
         default:
             msg_Warn( p_intf, "This should not happen %i", i );
             break;
diff --git a/modules/gui/qt4/main_interface.cpp b/modules/gui/qt4/main_interface.cpp
index cf443e0..5bc3cf6 100644
--- a/modules/gui/qt4/main_interface.cpp
+++ b/modules/gui/qt4/main_interface.cpp
@@ -300,6 +300,8 @@ MainInterface::~MainInterface()
     settings->setValue( "adv-controls",
                         getControlsVisibilityStatus() & CONTROLS_ADVANCED );
     settings->setValue( "status-bar-visible", b_statusbarVisible );
+    char* psz_medControls = var_GetString( p_intf, "med-view" );
+    settings->setValue( "med-controls", psz_medControls );
 
     /* Save the stackCentralW sizes */
     settings->setValue( "bgSize", stackWidgetsSizes[bgWidget] );
@@ -339,8 +341,11 @@ void MainInterface::recreateToolbars()
     delete controls;
     delete inputC;
 
-    controls = new ControlsWidget( p_intf, b_adv, this );
+    char* psz_medControls = var_GetString( p_intf, "med-view" );
+
+    controls = new ControlsWidget( p_intf, b_adv, qtr(psz_medControls),this );
     inputC = new InputControlsWidget( p_intf, this );
+
     mainLayout->insertWidget( 2, inputC );
     mainLayout->insertWidget( settings->value( "MainWindow/ToolbarPos", 0 ).toInt() ? 0: 3,
                               controls );
@@ -415,7 +420,10 @@ void MainInterface::createMainWidget( QSettings *creationSettings )
 
     /* Create the CONTROLS Widget */
     controls = new ControlsWidget( p_intf,
-        creationSettings->value( "MainWindow/adv-controls", false ).toBool(), this );
+        creationSettings->value( "MainWindow/adv-controls", false ).toBool(), 
+        creationSettings->value( "MainWindow/med-controls", qtr("showIfDetected") ).toString(), this );
+    CONNECT( THEMIM->getIM(), setMedControls( bool ),
+             controls, setMedControls( bool ) );
     inputC = new InputControlsWidget( p_intf, this );
 
     mainLayout->insertWidget( 2, inputC );
@@ -475,6 +483,7 @@ inline void MainInterface::createStatusBar()
     QStatusBar *statusBarr = statusBar();
 
     TimeLabel *timeLabel = new TimeLabel( p_intf );
+    CONNECT( THEMIM->getIM(), layersChanged( ), timeLabel, clearCache() );  /* for MED mode */
     nameLabel = new ClickableQLabel();
     nameLabel->setTextInteractionFlags( Qt::TextSelectableByMouse
                                       | Qt::TextSelectableByKeyboard );
@@ -961,6 +970,11 @@ int MainInterface::getControlsVisibilityStatus()
             + CONTROLS_ADVANCED * controls->b_advancedVisible );
 }
 
+QString MainInterface::getMedControlsSetting()
+{
+   return settings->value( "MainWindow/med-controls", qtr("showIfDetected") ).toString();
+}
+
 StandardPLPanel *MainInterface::getPlaylistView()
 {
     if( !playlistWidget ) return NULL;
diff --git a/modules/gui/qt4/main_interface.hpp b/modules/gui/qt4/main_interface.hpp
index 8a69193..56ed127 100644
--- a/modules/gui/qt4/main_interface.hpp
+++ b/modules/gui/qt4/main_interface.hpp
@@ -86,6 +86,7 @@ public:
         CONTROLS_ADVANCED = 0x4,
     };
     int getControlsVisibilityStatus();
+    QString getMedControlsSetting();
     bool isPlDocked() { return ( b_plDocked != false ); }
     bool isInterfaceFullScreen() { return b_interfaceFullScreen; }
     StandardPLPanel* getPlaylistView();
diff --git a/modules/gui/qt4/util/annotation_tooltip.cpp b/modules/gui/qt4/util/annotation_tooltip.cpp
new file mode 100644
index 0000000..d237989
--- /dev/null
+++ b/modules/gui/qt4/util/annotation_tooltip.cpp
@@ -0,0 +1,168 @@
+/*****************************************************************************
+ * Copyright © 2014 VideoLAN
+ * $Id$
+ *
+ * Authors: Roiy Shpaner <roiy@cs.umanitoba.ca>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
+ *****************************************************************************/
+
+#include "annotation_tooltip.hpp"
+
+#include <QApplication>
+#include <QPainter>
+#include <QPainterPath>
+#include <QBitmap>
+#include <QFontMetrics>
+#include <QDesktopWidget>
+
+#define TIP_HEIGHT 5
+
+AnnotationTooltip::AnnotationTooltip( QWidget *parent ) :
+    QWidget( parent ), mInitialized( false )
+{
+    setWindowFlags( Qt::Window                  |
+                    Qt::WindowStaysOnTopHint    |
+                    Qt::FramelessWindowHint     |
+                    Qt::X11BypassWindowManagerHint );
+
+    // Tell Qt that it doesn't need to erase the background before
+    // a paintEvent occurs. This should save some CPU cycles.
+    setAttribute( Qt::WA_OpaquePaintEvent );
+
+#if defined( Q_WS_WIN ) || defined( Q_WS_PM )
+    /*
+    - This attribute is required on Windows and OS/2 to avoid focus stealing of other windows.
+    - When set on Linux the AnnotationTooltip appears behind the FSController in fullscreen.
+    */
+    setAttribute( Qt::WA_ShowWithoutActivating );
+#endif
+
+    // Inherit from the system default font size -5
+    mFont = QFont( "Verdana", qMax( qApp->font().pointSize() - 5, 7 ) );
+    mTipX = -1;
+}
+
+void AnnotationTooltip::adjustPosition()
+{
+    // Get the bounding box required to print the text and add some padding
+    QFontMetrics metrics( mFont );
+    QRect textbox = metrics.boundingRect( mDisplayedText );
+    textbox.adjust( -5, 0, 2, 0 ); //Slight margins
+
+    textbox.moveTo( 0, TIP_HEIGHT );
+
+    // Resize the widget to fit our needs
+    QSize size( textbox.width() + 1, textbox.height() + TIP_HEIGHT + 1 );
+
+    // The desired label position is just below the target
+    QPoint position( mTarget.x() - size.width() / 2,
+        mTarget.y() + size.height() + TIP_HEIGHT / 2 );
+
+    // Keep the tooltip on the same screen if possible
+    QRect screen = QApplication::desktop()->screenGeometry( mTarget );
+    position.setX( qMax( screen.left(), qMin( position.x(),
+        screen.left() + screen.width() - size.width() ) ) );
+    position.setY( qMax( screen.top(), qMin( position.y(),
+        screen.top() + screen.height() - size.height() ) ) );
+
+    move( position );
+
+    int tipX = mTarget.x() - position.x();
+    if( mBox != textbox || mTipX != tipX )
+    {
+        mBox = textbox;
+        mTipX = tipX;
+
+        resize( size );
+        buildPath();
+        setMask( mMask );
+    }
+}
+
+void AnnotationTooltip::buildPath()
+{
+    // Prepare the painter path for future use so
+    // we only have to generate the text at runtime.
+
+    // Draw the text box
+    mPainterPath = QPainterPath();
+    mPainterPath.addRect( mBox );
+
+    // Draw the tip
+    QPolygon polygon;
+    polygon << QPoint( qMax( 0, mTipX - 3 ), TIP_HEIGHT)
+            << QPoint( mTipX, 0)
+            << QPoint( qMin( mTipX + 3, mBox.width() ), TIP_HEIGHT );
+    mPainterPath.addPolygon( polygon );
+
+    // Store the simplified version of the path
+    mPainterPath = mPainterPath.simplified();
+
+    // Create the mask used to erase the background
+    // Note: this is a binary bitmap (black & white)
+    mMask = QBitmap( size() );
+    QPainter painter( &mMask );
+    painter.fillRect( mMask.rect(), Qt::white );
+    painter.setPen( Qt::black );
+    painter.setBrush( Qt::black );
+    painter.drawPath( mPainterPath );
+    painter.end();
+}
+
+void AnnotationTooltip::setTip( const QPoint& target, const QString& layerName, const int& eventId, const QString& text )
+{
+    mInitialized = true;
+    mDisplayedText = layerName;
+    if ( !layerName.isEmpty() )
+        mDisplayedText.append( " (" + QString::number(eventId) + ")");
+
+    if (!text.isEmpty())
+        mDisplayedText.append(": " + ( text.split('\n') )[0] );
+
+    if( mTarget != target )
+    {
+        mTarget = target;
+        adjustPosition();
+    }
+
+    update();
+}
+
+void AnnotationTooltip::show()
+{
+    QWidget::setVisible( mInitialized );
+#ifdef Q_WS_PM
+    // Bring a tooltip on the top
+    // Without this, tooltip does not appear on fullscreen
+    // from the second fullscreen state change
+    if( mInitialized )
+        QWidget::raise();
+#endif
+}
+
+void AnnotationTooltip::paintEvent( QPaintEvent * )
+{
+    QPainter p( this );
+    p.setRenderHints( QPainter::HighQualityAntialiasing | QPainter::TextAntialiasing );
+
+    p.setPen( Qt::black );
+    p.setBrush( qApp->palette().base() );
+    p.drawPath( mPainterPath );
+
+    p.setFont( mFont );
+    p.setPen( QPen( qApp->palette().text(), 1 ) );
+    p.drawText( mBox, 0x0024 , mDisplayedText );    //0x0024 = Qt::AlignTop + Qt::AlignHCenter
+}
diff --git a/modules/gui/qt4/util/annotation_tooltip.hpp b/modules/gui/qt4/util/annotation_tooltip.hpp
new file mode 100644
index 0000000..ef61126
--- /dev/null
+++ b/modules/gui/qt4/util/annotation_tooltip.hpp
@@ -0,0 +1,58 @@
+/*****************************************************************************
+ * Copyright © 2014 VideoLAN
+ * $Id$
+ *
+ * Authors: Roiy Shpaner <roiy@cs.umanitoba.ca>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
+ *****************************************************************************/
+
+#ifndef ANNOTATION_TOOLTIP_H
+#define ANNOTATION_TOOLTIP_H
+
+#include <QWidget>
+#include <QBitmap>
+
+class QPaintEvent;
+class QString;
+class QFont;
+class QRect;
+class QPainterPath;
+
+class AnnotationTooltip : public QWidget
+{
+    Q_OBJECT
+public:
+    explicit AnnotationTooltip( QWidget *parent = 0 );
+    void setTip( const QPoint& target, const QString& layerName, const int& eventId, const QString& text );
+    virtual void show();
+
+protected:
+    virtual void paintEvent( QPaintEvent * );
+
+private:
+    void adjustPosition();
+    void buildPath();
+    QPoint mTarget;
+    QString mDisplayedText;
+    QFont mFont;
+    QRect mBox;
+    QPainterPath mPainterPath;
+    QBitmap mMask;
+    int mTipX;
+    bool mInitialized;
+};
+
+#endif // ANNOTATION_TOOLTIP_H
-- 
1.8.4.msysgit.0

